﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestModelFirst
{
   public partial class Form1 : Form
   {
      public Form1()
      {
         InitializeComponent();
      }

      private void btnAdd_Click(object sender, EventArgs e)
      {
         // Create a new purchase.
         Purchases NewPurchase = new Purchases();
         NewPurchase.Amount = new Decimal(5.99);
         NewPurchase.PurchaseDate = DateTime.Now;

         // Create a new customer and add the purchase.
         Customers NewCustomer = new Customers();
         NewCustomer.CustomerName = "Josh Bailey";

         // Create the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Add the record and save it.
         context.Customers.Add(NewCustomer);
         context.Purchases.Add(NewPurchase);
         context.SaveChanges();

         // Display a success message.
         MessageBox.Show("Record Added");
      }

      private void btnQuery_Click(object sender, EventArgs e)
      {
         // Obtain the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Create a variable to hold the ordered data.
         IOrderedQueryable<ViewClient> OrderedData = null;

         // Determine the data order.
         switch (cbOrderBy.SelectedIndex)
         {
            case 0:
               OrderedData = context.ViewClients.OrderBy(value => value.Amount);
               break;
            case 1:
               OrderedData = context.ViewClients.OrderBy(value => value.CustomersId);
               break;
            case 2:
               OrderedData = context.ViewClients.OrderBy(value => value.PurchaseDate);
               break;
            default:
               OrderedData = context.ViewClients.OrderBy(value => value.PurchaseDate);
               break;
         }

         // Define a variable to hold the output.
         StringBuilder Output = new StringBuilder();

         // Create the application output.
         foreach (var Client in OrderedData)
            Output.Append(Client.CustomerName + " ID " +
               Client.CustomersId + " purchased " +
               Client.Amount + " on " +
               Client.PurchaseDate + ".\r\n");

         // Show the output on screen.
         MessageBox.Show(Output.ToString());
      }

      private void btnAdd2_Click(object sender, EventArgs e)
      {
         // Obtain the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Add a new record to the database.
         context.AddClient(
            "Carole Poland", new DateTime(2013, 04, 16), new Decimal(20.99));

         // Display a success message.
         MessageBox.Show("Record Added Successfully");
      }

      private void btnUpdate_Click(object sender, EventArgs e)
      {
         // Obtain the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Locate the specified record.
         IQueryable<ViewClient> Record = context.ViewClients
            .Where(CustName => CustName.CustomerName == "Carole Poland")
            .Where(PurchDate => PurchDate.PurchaseDate.Equals(new DateTime(2013, 04, 16)))
            .Where(PurchAmount => PurchAmount.Amount.Equals(new Decimal(20.99)));

         // Modify the data.
         context.UpdateClient(Record.First().Id, "Carole Poland", 
            new DateTime(2013, 04, 17), new Decimal(25.99));

         // Display a success message.
         MessageBox.Show("Record Updated Successfully");
      }

      private void btnDelete_Click(object sender, EventArgs e)
      {
         // Obtain the context.
         Rewards2ModelContainer context = new Rewards2ModelContainer();

         // Locate the specified record.
         IQueryable<ViewClient> Record = context.ViewClients
            .Where(CustName => CustName.CustomerName == "Carole Poland")
            .Where(PurchDate => PurchDate.PurchaseDate.Equals(new DateTime(2013, 04, 17)))
            .Where(PurchAmount => PurchAmount.Amount.Equals(new Decimal(25.99)));

         // Modify the data.
         context.DeleteClient(Record.First().Id);

         // Display a success message.
         MessageBox.Show("Record Deleted Successfully");
      }
   }
}
